package ru.dbotthepony.mc.otm.client.render.entity

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.model.HierarchicalModel
import net.minecraft.client.renderer.MultiBufferSource
import net.minecraft.client.renderer.RenderType
import net.minecraft.client.renderer.entity.EntityRendererProvider
import net.minecraft.client.renderer.entity.MobRenderer
import net.minecraft.client.renderer.entity.layers.RenderLayer
import net.minecraft.client.renderer.texture.OverlayTexture
import net.minecraft.resources.ResourceLocation
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.OverdriveThatMatters.loc
import ru.dbotthepony.mc.otm.client.model.entity.EnforcerModel
import ru.dbotthepony.mc.otm.entity.Enforcer

class EnforcerRenderer(context: EntityRendererProvider.Context)
	: MobRenderer<Enforcer, HierarchicalModel<Enforcer>>(context, EnforcerModel.getModel(), 2.2f) {
	override fun getTextureLocation(entity: Enforcer): ResourceLocation = TEXTURE_LOCATION

	init {
		this.addLayer(EnforcerEmissiveLayer(this, model))
	}
	companion object {
		private val TEXTURE_LOCATION = loc("textures/entity/enforcer.png")
	}
}

class EnforcerEmissiveLayer(
	entityRenderer: EnforcerRenderer,
	model: HierarchicalModel<Enforcer>
) : RenderLayer<Enforcer, HierarchicalModel<Enforcer>>(entityRenderer) {

	private val emissive = loc("textures/entity/enforcer_emissive.png")


	override fun render(
		poseStack: PoseStack,
		bufferSource: MultiBufferSource,
		packedLight: Int,
		entity: Enforcer,
		limbSwing: Float,
		limbSwingAmount: Float,
		partialTicks: Float,
		ageInTicks: Float,
		netHeadYaw: Float,
		headPitch: Float
	) {
		val buffer = bufferSource.getBuffer(RenderType.eyes(emissive))

		this.parentModel.renderToBuffer(
			poseStack,
			buffer,
			15728640,
			OverlayTexture.NO_OVERLAY
		)
	}
}
